<?php

namespace App\Api\Controllers;

use App\Http\Controllers\BaseApiController;
use App\Models\DiagnosiModel;
use App\Models\DoctorModel;
use App\Models\InquiryModel;
use App\Models\PatientModel;
use App\Models\PharmacistModel;
use App\Models\PharmacyDrugModel;
use App\Models\PharmacyModel;
use App\Models\PrescriptionLogModel;
use App\Models\PrescriptionModel;
use App\Models\User;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

// 问诊人控制器
class PrescriptionController extends BaseApiController
{
    public function test()
    {
        // 分派医师 医师当日开方未达到上限以及是否在时间段的搜索出来
        // $site_config = DB::table('admin_settings')->where('slug', 'site_config')->value('value');
        // $site_config = json_decode($site_config, true);
        // $pharmacy = PharmacyDrugModel::where('pharmacy_id',1)->get();
        $doctors = DoctorModel::query()->where('status', 1)->get();
        $randomDoctor = $doctors->random();

        return $this->success($randomDoctor);
    }

    // 处方列表
    public function prescriptionList(Request $request)
    {
        $authInfo = auth('api')->user();
        $query = PrescriptionModel::query();
        // TODO 判断当前登录的用户角色
        // $userInfo = User::with(['doctor', 'pharmacist'])->find($authInfo->id);
        if ($authInfo->last_login_type == User::LOGIN_TYPE_USER) {
            $query->where('user_id', $authInfo->id);
        } elseif ($authInfo->last_login_type == User::LOGIN_TYPE_DOCTOR) { // 医师
            $doctor = DoctorModel::query()->where('user_id', $authInfo->id)->first();
            $query->where('doctor_id', $doctor->id);
        } elseif ($authInfo->last_login_type == User::LOGIN_TYPE_PHARMACY) { // 药店
            $pharmacy = PharmacyModel::query()->where('user_id', $authInfo->id)->first();
            $query->where('pharmacy_id', $pharmacy->id);
        }

        // 时间段
        $start_time = $request->input('start_time');
        if ($start_time) {
            $query->where('created_at', '>=', $start_time);
        }
        $end_time = $request->input('end_time');
        if ($end_time) {
            $query->where('created_at', '<=', $end_time);
        }

        // 状态
        $status = $request->input('status');
        if ($status) {
            $query->where('status', $status);
        }

        // 分页
        $page = $request->input('page', 1);
        $perPage = $request->input('per_page', 10);
        $prescription = $query->orderBy('id', 'desc')->paginate($perPage, ['*'], 'page', $page);

        // $prescription = $query->paginate(10);
        return $this->success($prescription);
    }

    // 处方详情
    public function detail(Request $request)
    {
        $prescription_id = $request->input('prescription_id');
        $prescription = PrescriptionModel::query()->where('id', $prescription_id)->first();

        return $this->success($prescription);
    }

    // 开方
    public function create(Request $request)
    {
        $authInfo = auth('api')->user();
        $pharmacy_id = $request->input('pharmacy_id', 0);
        $patient_id = $request->input('patient_id');
        $diagnosis_id = $request->input('diagnosis_id');
        $inquirys = $request->input('inquirys'); // [['inquiry_id'=>1,'answer'=>1]]
        $drugs = $request->input('drugs'); // [['pharmacy_drug_id'=>2,'num'=>1]]
        $pharmacy = null;
        // 获取当前用户信息,如果是药店则无需传pharmacy_id参数
        if ($authInfo->last_login_type == User::LOGIN_TYPE_PHARMACY) {
            $pharmacy = PharmacyModel::where('user_id', $authInfo->id)->first();
            $pharmacy_id = $pharmacy->id;
        } elseif ($authInfo->last_login_type == User::LOGIN_TYPE_DOCTOR) {
            $pharmacy = PharmacyModel::find($pharmacy_id);
            if (! $pharmacy) {
                return $this->failed('药店信息不存在');
            }
        } else {
            return $this->failed('pharmacy_id不能为空');
        }

        // 生成处方
        $prescription = new PrescriptionModel;
        $prescription->status = PrescriptionModel::PRESCRIPTION_STATUS_PENDING;
        $prescription->user_id = $authInfo->id; // 获取当前用户ID
        // 问诊人信息
        $patient = PatientModel::find($patient_id);
        $prescription->patient_id = $patient_id; // 问诊人编号
        $prescription->patient_name = $patient->name; // 问诊人姓名
        $prescription->patient_age = getAgeByIdCard($patient->id_card); // 问诊人年龄
        $prescription->patient_gender = $patient->gender; // 问诊人性别
        // 诊断信息
        $prescription->diagnosis_id = $diagnosis_id;
        $prescription->diagnosis_name = DiagnosiModel::find($diagnosis_id)->value('name');
        // 问诊问题
        $inquiry_info = [];
        $is_abnormal = 0; // 是否异常处方单，只有一个问题回答是就是异常
        foreach ($inquirys as $inquiry) {
            $inquiry_info[] = [
                'inquiry_id' => $inquiry['inquiry_id'],
                'question' => InquiryModel::find($inquiry['inquiry_id'])->value('question'),
                'answer' => $inquiry['answer'] == 1 ? 1 : 0, // [1 => '是', 0 => '否']
            ];
            // 检查是否有一个answer是1
            if ($inquiry['answer'] == 1) {
                $is_abnormal = 1; // 如果有一个answer是1，设置$is_abnormal为1
            }
        }
        $prescription->inquiry_info = $inquiry_info;
        // 用药信息
        $drug_info = [];
        foreach ($drugs as $drug) {
            $pharmacyDrugQueryInfo = PharmacyDrugModel::with(['drug', 'dosage'])->find($drug['pharmacy_drug_id']);
            $drug_info[] = [
                'pharmacy_drug_id' => $drug['pharmacy_drug_id'],
                'drug_id' => $pharmacyDrugQueryInfo->drug_id,
                'drug_name' => $pharmacyDrugQueryInfo->drug->name,
                'unit' => $pharmacyDrugQueryInfo->unit,
                'dosage_id' => $pharmacyDrugQueryInfo->dosage_id,
                'dosage_desc' => $pharmacyDrugQueryInfo->dosage->dosage_desc,
                'num' => $drug['num'],
            ];
        }
        $prescription->drug_info = $drug_info;

        // 获取全局开方配置
        $site_config = admin_setting_array('site_config');
        $prescription_limit = $site_config['prescription_limit'];
        $prescription_period_status = $site_config['prescription_period_status'];
        $prescription_period_start = $site_config['prescription_period_start'];
        $prescription_period_end = $site_config['prescription_period_end'];
        $prescription_limit_buy_7 = $site_config['prescription_limit_buy_7'];

        // 分派医师  医师当日开方未达到上限以及是否在时间段的搜索出来

        if ($prescription_period_status == '1') {
            // 获取当前时间
            $currentTime = Carbon::now();
            // 解析开始和结束时间
            $startTime = Carbon::createFromFormat('H:i', $prescription_period_start);
            $endTime = Carbon::createFromFormat('H:i', $prescription_period_end);
            // 判断当前时间是否在范围内
            if (! $currentTime->between($startTime, $endTime)) {
                return $this->failed('当前时间不在开方时间段内');
            }
        }

        if (intval($prescription_limit) > 0) {
            $startOfDay = Carbon::now()->startOfDay();
            $endOfDay = Carbon::now()->endOfDay();
            $doctorIds = DoctorModel::query()->where('status', DoctorModel::STATUS_TRUE)->pluck('id')->toArray();
            $prescriptionCounts = PrescriptionModel::select('doctor_id', DB::raw('COUNT(*) as prescription_count'))
                ->whereIn('doctor_id', $doctorIds)
                ->whereBetween('created_at', [$startOfDay, $endOfDay])
                ->groupBy('doctor_id')
                ->pluck('prescription_count', 'doctor_id');

            // 筛选未达到上限的医师
            $availableDoctors = collect($doctorIds)->filter(function ($doctorId) use ($prescriptionCounts, $prescription_limit) {
                return $prescriptionCounts->get($doctorId, 0) < $prescription_limit;
            })->values()->all();
            // 随机取一个随机医师
            $randomDoctor = DoctorModel::whereIn('id', $availableDoctors)
                ->where('status', DoctorModel::STATUS_TRUE)
                ->inRandomOrder()
                ->first();

        } else {
            $randomDoctor = DoctorModel::inRandomOrder()->where('status', DoctorModel::STATUS_TRUE)->first();
        }

        $prescription->doctor_id = $randomDoctor->id;
        $prescription->doctor_name = $randomDoctor->mame;
        $prescription->doctor_online_hospital_name = $randomDoctor->online_hospital_name;
        $prescription->doctor_department = $randomDoctor->department;
        $prescription->doctor_title = $randomDoctor->doctor_title;
        $prescription->doctor_license_no = $randomDoctor->license_no;
        $prescription->doctor_signed_pic = $randomDoctor->getRawOriginal('signed_pic');
        // 药店信息
        $prescription->pharmacy_id = $pharmacy->id;
        $prescription->pharmacy_name = $pharmacy->name;
        // 分派药师,先搜索是否存在默认药师，如果不存在则随机抽取一个
        $pharmacist = PharmacistModel::where('status', 1)
            ->where('pharmacy_id', $pharmacy_id)
            ->where(function ($query) {
                $query->where('is_default', 1)
                    ->orWhere('is_default', 0);
            })
            ->inRandomOrder()
            ->first();
        $prescription->pharmacist_id = $pharmacist->id;
        $prescription->pharmacist_name = $pharmacist->name;
        $prescription->pharmacist_license_number = $pharmacist->license_number;
        $prescription->pharmacist_signed_pic = $pharmacist->getRawOriginal('signed_pic');

        // 生成处方单信息
        $prescription_at = Carbon::now()->subMinutes(12);
        $review_at = Carbon::now()->subMinutes(10);
        // 默认为15分钟前的时间
        $prescription->created_at = Carbon::now()->subMinutes(15);
        $prescription->updated_at = Carbon::now()->subMinutes(15);
        $prescription->prescription_at = $prescription_at;
        $prescription->review_at = $review_at;
        $prescription->is_abnormal = $is_abnormal;

        $prescription_number = 0;
        if ($prescription->save()) {
            $prescription_number = $prescription->id;
        } else {
            return $this->failed('生成处方单失败');
        }

        // 判断是否为医师自动开方
        // $prescription_auto = $site_config['prescription_auto'];
        if ($randomDoctor->is_auto == 1) {
            $prescription->status = PrescriptionModel::PRESCRIPTION_STATUS_REVIEWING;
            $prescription->save();
            // 生成医师开方日志
            $doctorLog = new PrescriptionLogModel;
            $doctorLog->pharmacy_id = $pharmacy_id;
            $doctorLog->pharmacy_name = $pharmacy->name;
            $currentTime = $prescription_at;
            $doctorLog->log_info = $randomDoctor->mame.'在'.$prescription_at.'为'.$patient->name.'（'.$patient->mobile.'）开具处方单（处方单编号：'.$prescription_number.'）';
            $doctorLog->save();
        }

        if ($pharmacy->is_auto == 1) {
            $prescription->status = PrescriptionModel::PRESCRIPTION_STATUS_SUCCESS;
            $prescription->save();
            // 生成药师审方日志
            $pharmacistLog = new PrescriptionLogModel;
            $pharmacistLog->pharmacy_id = $pharmacy_id;
            $pharmacistLog->pharmacy_name = $pharmacy->name;
            $currentTime = $review_at;
            $pharmacistLog->log_info = $pharmacist->name.'在'.$review_at.'为'.$patient->name.'（'.$patient->mobile.'）审方(处方单编号：'.$prescription_number.')';
            $pharmacistLog->save();
        }

        return $this->success('ok');

    }
}
